
#include <stdio.h>
#include <native/mutex.h>

RT_MUTEX mutex_desc;

int main (int argc, char *argv[])

{
    int err;

    /* Create a mutex; we could also have attempted to bind to some
       pre-existing object, using rt_mutex_bind() and rt_mutex_bind()
       instead of creating it. In any case, priority inheritance is
       automatically enforced for mutual exclusion locks. */

    err = rt_mutex_create(&mutex_desc,"MyMutex");
    if (err)
      printf("rt_mutex_create: %d", err);

    /* Now, grab the mutex lock, run the critical section, then
       release the lock: */

    err = rt_mutex_lock(&mutex_desc,TM_INFINITE); // 0.8.99
    if (err)
      printf("rt_mutex_create: %d", err);

    /* ... Critical section ... */
    
    err = rt_mutex_unlock(&mutex_desc);
    if (err)
      printf("rt_mutex_create: %d", err);

    /* ... */
    return err;
}

void cleanup (void)

{
    rt_mutex_delete(&mutex_desc);
}
